/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { Point_$type, enumGetBox, typeCast, runOn, delegateCombine, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
export let AnchoredCategorySeries = /*@__PURE__*/ (() => {
    class AnchoredCategorySeries extends CategorySeries {
        get aai() {
            if (this.aah == null) {
                this.aah = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.dp.n);
            }
            return this.aah;
        }
        getHostReferenceValue() {
            return this.iw();
        }
        mb() {
            return AnchoredCategorySeries.$$p[5];
        }
        cq() {
            let a = new AnchoredCategorySeriesView(this);
            return a;
        }
        qw(a) {
            super.qw(a);
            this.aad = a;
        }
        constructor() {
            super();
            this.aah = null;
            this.aam = false;
            this.aaj = null;
            this.aae = null;
            this.aat = null;
            this.aas = null;
            this.aal = true;
            this.aan = 0;
            this.aao = 0;
            this.yp = new CategoryFramePreparer(1, this, this.yt, this, this, this.yt.cw);
        }
        ko(a, b) {
            let c = this.na(b);
            if (c == AnchoredCategorySeries.$$p[5]) {
                return this.kp(a, b, this.aa3);
            }
            if (c == AnchoredCategorySeries.$$p[1]) {
                return this.kp(a, b, this.aav);
            }
            return super.ko(a, b);
        }
        ma(a) {
            let b = this.na(a);
            if (b == AnchoredCategorySeries.$$p[5]) {
                return this.aa3;
            }
            if (b == AnchoredCategorySeries.$$p[1]) {
                return this.aav;
            }
            return super.ma(a);
        }
        get valueColumn() {
            return this.aaj;
        }
        set valueColumn(a) {
            if (this.aaj != a) {
                let b = this.aaj;
                this.aaj = a;
                if (!this.aam) {
                    this.raisePropertyChanged("ValueColumn", b, this.aaj);
                }
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = new DataLegendSeriesValueInfo();
            c.a = 0;
            c.l = this.i3({ $type: Point_$type, x: a, y: b }, false, false);
            c.r = this.aa3 != null ? this.aa3 : "Value";
            c.q = "Value";
            c.s = this.aaz != null ? this.aaz : "V:";
            c.t = this.aa1 != null ? this.aa1 : "";
            let d = new DataLegendSeriesContext();
            d.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(c);
                return $ret;
            })());
            d.h = this.l9();
            return d;
        }
        get abq() {
            return this.c(AnchoredCategorySeries.abc);
        }
        set abq(a) {
            this.h(AnchoredCategorySeries.abc, a);
        }
        gb(a) {
            let b = new Rect(0, 0, 0, 1, 1);
            let c = this.fetchXAxis();
            let d = this.fetchYAxis();
            let e = this.we(this.ct);
            let f = c != null ? this.yp.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
            return this.aai.c$a(this, this.valueColumn, c, d, f, a);
        }
        aaa(a, b, c) {
            if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cn;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.dl.item(g);
            }
            return d;
        }
        q4(a, b, c, d) {
            super.q4(a, b, c, d);
            if (this.aad.c8 && this.aad.c7.g$b(a, b, c, d)) {
                let e = false;
                if (b == "FastItemsSource") {
                    e = this.ge && c != null;
                }
                this.rm(e);
                this.qg();
            }
            switch (b) {
                case AnchoredCategorySeries.$$p[3]:
                case AnchoredCategorySeries.$$p[4]:
                    this.qa();
                    break;
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.valueColumn);
                        this.valueColumn = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.valueColumn = this.di(this.aa3);
                    }
                    let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (f != null && !f.c1()) {
                        this.aad.cw.g(this.ib);
                        this.rm(this.ge && c != null);
                    }
                    break;
                case AnchoredCategorySeries.$$p[5]:
                    if (this.dl != null) {
                        this.dl.deregisterColumn(this.valueColumn);
                        this.valueColumn = this.di(this.aa3);
                    }
                    this.aat = this.aa3;
                    break;
                case AnchoredCategorySeries.$$p[1]:
                    this.aas = this.aav;
                    this.rm(true);
                    break;
                case "ValueColumn":
                    if (this.aad.c8) {
                        this.aad.c7.g$i();
                    }
                    let g = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (g != null && !g.c1()) {
                        this.aad.cw.g(this.ib);
                        this.rm(this.ge && this.d5);
                    }
                    this.abb();
                    this.sg();
                    break;
                case "TrendLineBrush":
                    this.ra(b);
                    break;
                case "ErrorBarSettings":
                    this.rm(false);
                    break;
                case "TrendLineType":
                    this.qg();
                    break;
                case AnchoredCategorySeries.$$p[2]:
                    this.rm(false);
                    break;
            }
        }
        ax(a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        }
        o8(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.aad.cw.g(this.ib);
                    break;
            }
            if (this.aad.c8) {
                this.aad.c7.g$e(a, b, c, d);
            }
            this.abb();
            this.sg();
            if (a == 0 || a == 2 || a == 3 || a == 4) {
                this.aal = true;
            }
            else if (a == 1) {
                for (let e = b; e < b + c; e++) {
                    this.aan += this.valueColumn.item(e);
                }
                this.aao = this.aan / this.valueColumn.count;
            }
        }
        zk() {
            return this.aap(this.yt);
        }
        aap(a) {
            let b = 0;
            let c = a.by;
            let d = a.bx;
            let e = this.getEffectiveViewport1(a);
            let f = typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!c.isEmpty && !d.isEmpty && f != null) {
                let g = new ScalerParams(0, c, d, f.ch, e);
                if (f.cp) {
                    g.b = this.iw();
                }
                b = f.ek(f.l8, g);
            }
            return b;
        }
        aa9(a, b, c) {
            let d = this.aap(c);
            if (a.count > 0) {
                let e = d;
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
            }
        }
        aab(a, b, c, d) {
            return this.aac(a, b, c, d, false);
        }
        aac(a, b, c, d, e) {
            return CategorySeries.ye(a, b, c, d, e);
        }
        f9() {
            return this.highlightedItemsSource != null || this.aav != null;
        }
        hr() {
            let a = super.hr();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "ValueMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedValueMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.aa5));
                a.add(b);
            }
            return a;
        }
        aa5(a, b) {
            if (this.aav != null) {
                b.value = this.aav;
                return;
            }
            b.value = this.aa3;
        }
        hc(a, b, c) {
            let d = super.hc(a, b, c);
            let e = c;
            if (this.valueColumn == null || this.valueColumn.count == 0 || e.cw.d < 1) {
                d = false;
            }
            return d;
        }
        o2(a, b) {
            super.o2(a, b);
            let c = b;
            c.c2();
            if (c.c8) {
                c.c7.g$d();
            }
        }
        z0(a, b) {
            super.z0(a, b);
            this.yq(b).d(a, b);
        }
        z3(a, b) {
            super.z3(a, b);
            let c = typeCast(AnchoredCategorySeriesView.$, b);
            c.b7 = true;
            if (c.c8) {
                c.c7.g$g(a.q);
            }
            if (this.w7()) {
                CategoryMarkerManager.e(this, a.n, b.cz, this.w9);
                this.zx(b, a);
                b.cr();
            }
            this.aa6(a, b);
        }
        rl(a, b, c, d, e) {
            super.rl(a, b, c, d, e);
            let f = this.a9.a$j.item(d);
            let g = f;
            g.cw.g(this.ib);
            f.a3(c);
            if (this.d3(g)) {
                return;
            }
            if (this.aae == null) {
                this.aae = new CategoryFrame(3);
            }
            this.aae.v();
            this.z0(this.aae, g);
            this.z3(this.aae, g);
        }
        aa6(a, b) {
        }
        sa() {
            super.sa();
            if (this.index < 0) {
                return;
            }
            this.aad.dc();
            if (this.trendLineBrush != null) {
                this.aad.da();
            }
            else {
                this.aad.c9();
            }
        }
        ku(a, b) {
            if (this.aad.c8 && a == this.aad.c7.g$j) {
                return null;
            }
            return super.ku(a, b);
        }
        get currentCategoryMode() {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.yj()));
        }
        get scaler() {
            return typeCast(ICategoryScaler_$type, this.yj());
        }
        get yScaler() {
            return typeCast(IScaler_$type, this.yz());
        }
        get bucketizer() {
            return this.aad.cw;
        }
        get currentMode2Index() {
            return this.zo();
        }
        provideCollisionDetector() {
            if (this.aaf == 1) {
                return new CollisionAvoider();
            }
            return NonCollisionAvoider.b;
        }
        get trendlinePreparer() {
            return this.aad.c8 ? this.aad.c7 : null;
        }
        pu(a) {
            super.pu(a);
            if (this.aad.c8) {
                this.bb.exportTrendlineData(this, a, this.aad.c7.g$j);
            }
        }
        kl(a) {
            let b = this.fetchXAxis();
            let c = this.fetchYAxis();
            return this.aai.c$b(this, a, this.zl(this.ct), this.valueColumn, b, c, this.aag == 1, (d) => super.kl(d));
        }
        get mayContainUnknowns() {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        }
        iw() {
            return Series.ix(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
        }
        get_aar() {
            return 0;
        }
        get aar() {
            return this.get_aar();
        }
        ay(a) {
            if (a.isEmpty && this.c9 != null) {
                a = this.c9.vl;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.wc(this.ct);
            let c = this.yj();
            let d = new ScalerParams(0, a, this.c9.v0, c.ch, this.getEffectiveViewport());
            let e = (c.en(b.left, d));
            let f = (c.en(b.right, d));
            if (c.ch) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.aar;
            f += this.aar;
            let h = null;
            if (c.cn) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.aw(n, this.yz(), a);
            return n;
        }
        abb() {
            this.ik = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
        }
        aba() {
            if (this.aal) {
                this.aan = 0;
                for (let a = 0; a < this.valueColumn.count; a++) {
                    this.aan += this.valueColumn.item(a);
                }
                this.aao = this.aan / this.valueColumn.count;
                this.aal = false;
            }
        }
        i6(a, b) {
            if (b == null || !b.cj) {
                return NaN;
            }
            let c = this.yz();
            if (b != c) {
                return NaN;
            }
            let d = this.ap(a);
            if (c.cp) {
                return d[1];
            }
            else {
                return d[0];
            }
        }
        ap(a) {
            let b = NaN;
            switch (a) {
                case 5:
                case 2:
                    b = this.valueColumn.maximum;
                    break;
                case 4:
                case 1:
                    b = this.valueColumn.minimum;
                    break;
                case 6:
                case 3:
                    if (this.aal) {
                        this.aba();
                    }
                    b = this.aao;
                    break;
            }
            let c = this.yz();
            if (c.cp) {
                return [NaN, b];
            }
            else {
                return [b, NaN];
            }
        }
        v8(a) {
            let b = NaN;
            switch (a) {
                case 5:
                case 2:
                    b = this.valueColumn.maximum;
                    break;
                case 4:
                case 1:
                    b = this.valueColumn.minimum;
                    break;
                case 6:
                case 3:
                    if (this.aal) {
                        this.aba();
                    }
                    b = this.aao;
                    break;
            }
            if (isNaN_(b)) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let c = this.yz();
            let d = this.getEffectiveViewport1(this.ct);
            let e = new ScalerParams(0, this.ct.by, this.ct.bx, c.ch, d);
            if (c.cp) {
                e.b = this.iw();
            }
            e.c = d;
            if (c.cp) {
                return { $type: Point_$type, x: NaN, y: c.ek(b, e) };
            }
            else {
                return { $type: Point_$type, x: c.ek(b, e), y: NaN };
            }
        }
        v9(a) {
            let b = this.yz();
            let c = this.getEffectiveViewport1(this.ct);
            let d = new ScalerParams(0, this.ct.by, this.ct.bx, b.ch, c);
            if (b.cp) {
                d.b = this.iw();
            }
            d.c = c;
            if (b.cp) {
                return { $type: Point_$type, x: NaN, y: b.ek(a[1], d) };
            }
            else {
                return { $type: Point_$type, x: b.ek(a[0], d), y: NaN };
            }
        }
        get useHighMarkerFidelity() {
            return this.zg;
        }
    }
    AnchoredCategorySeries.$t = /*@__PURE__*/ markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.abc = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:aag:abd', [ConsolidatedItemHitTestBehavior_$type, /*@__PURE__*/ enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'HighlightedValueMemberPath:aav:abe', [2, null], 'MarkerCollisionAvoidance:aaf:abf', [CategorySeriesMarkerCollisionAvoidance_$type, /*@__PURE__*/ enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberAsLegendLabel:aaz:abn', [2, null], 'ValueMemberAsLegendUnit:aa1:abo', [2, null], 'ValueMemberPath:aa3:abp', [2, null], 'TrendLineType::abl', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::abk', [1, 1.5], 'TrendLinePeriod::abj', [1, 7], 'TrendLineBrush::abg', [Brush.$, null], 'TrendLineZIndex:aaq:abm', [1, 1001], 'TrendLineDashArray:abr:abh', [DoubleCollection.$], 'TrendLineDashCap:abs:abi', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
})();
/**
 * @hidden
 */
export let AnchoredCategoryBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.i = null;
            this.h = null;
            this.j = 0;
            this.i = a;
        }
        getBucketWithoutUnknowns(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 1.7976931348623157E+308;
            let h = -1.7976931348623157E+308;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        getBucket(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                if (!i) {
                    if (!isNaN_(k)) {
                        g = g < k ? g : k;
                        h = h > k ? h : k;
                    }
                }
                else {
                    if (!isNaN_(k)) {
                        g = k;
                        h = k;
                        i = false;
                    }
                }
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        cacheValues() {
            this.j = this.i.c5.valueColumn.count;
            this.h = this.i.c5.valueColumn.asArray();
        }
        unCacheValues() {
            this.h = null;
        }
    }
    AnchoredCategoryBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredCategorySeriesView = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesView extends CategorySeriesView {
        constructor(a) {
            super(a);
            this.c5 = null;
            this.c6 = null;
            this.c5 = a;
        }
        get c7() {
            if (this.c6 == null) {
                this.c6 = CategoryTrendLineManagerFactory.a(this.c6, this.e.az(), this.e.so, this.e, this.e.dp);
            }
            return this.c6;
        }
        set c7(a) {
            this.c6 = a;
        }
        get c8() {
            return this.c6 != null;
        }
        dc() {
            this.c5.abq = null;
        }
        da() {
            this.c5.abq = this.c5.trendLineBrush;
        }
        c9() {
            this.c5.abq = this.c5.u2;
        }
        cx() {
            return new AnchoredCategoryBucketCalculator(this);
        }
        db() {
            this.cw.cacheValues();
        }
        dd() {
            this.cw.unCacheValues();
        }
        de(a) {
            let b = this.cz.item(a);
            return this.cu(b);
        }
        a7(a, b) {
            if (a.d) {
                if (this.c5.trendLineType != 0 && !b) {
                    let c = this.c7.g$j;
                    c.ad = this.c5.trendLineThickness;
                    c._stroke = this.c5.abq;
                    c.ai = this.c5.abr;
                    c.aj = this.c5.abs;
                    a.v(c);
                }
            }
            super.a7(a, b);
        }
        getDefaultTooltipTemplate() {
            return this.c5.aai.c$c(this.e, this.c5.aa3);
        }
    }
    AnchoredCategorySeriesView.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
})();
